From c30a77bfb6231b2f0955b968cee92a0a9dbdc316 Mon Sep 17 00:00:00 2001
From: Stephanie Buser <sbuser@codeaurora.org>
Date: Sat, 3 Oct 2020 22:47:55 +0530
Subject: [PATCH 04/10] Battery & Fuel Guage Changes

---
 ql-ol-kernel/drivers/power/Kconfig                 | 12 ++++
 ql-ol-kernel/drivers/power/Makefile                |  2 +
 ql-ol-kernel/drivers/power/bq27441_battery.c       | 69 +++++++++++++++++-----
 ql-ol-kernel/drivers/thermal/thermal_core.c        | 23 ++++++++
 ql-ol-kernel/include/linux/power/bq27441_battery.h |  5 ++
 ql-ol-kernel/include/linux/thermal.h               |  4 ++
 6 files changed, 101 insertions(+), 14 deletions(-)

diff --git a/ql-ol-kernel/drivers/power/Kconfig b/ql-ol-kernel/drivers/power/Kconfig
index 7709550..2a58691 100755
--- a/ql-ol-kernel/drivers/power/Kconfig
+++ b/ql-ol-kernel/drivers/power/Kconfig
@@ -462,6 +462,15 @@ config SMB23X_CHARGER
 	  The driver reports the charger status via the power supply framework.
 	  A charger status change triggers an IRQ via the device STAT pin.
 
+config BATTERY_BQ27441
+        tristate "TI's BQ27441 Fuel Gauge"
+        depends on I2C
+        select BATTERY_CHARGER_GAUGE_COMM
+        default y
+        help
+          BQ27441 is fuel-gauge systems for lithium-ion (Li+) batteries
+          in handheld and portable equipment.
+
 config BATTERY_BQ28400
 	tristate "BQ28400 battery driver"
 	depends on I2C
@@ -595,6 +604,9 @@ config MSM_BCL_PERIPHERAL_CTL
 	  provides routines to configure and monitor the BCL
 	  PMIC peripheral.
 
+config BATTERY_CHARGER_GAUGE_COMM
+        bool
+
 source "drivers/power/reset/Kconfig"
 
 endif # POWER_SUPPLY
diff --git a/ql-ol-kernel/drivers/power/Makefile b/ql-ol-kernel/drivers/power/Makefile
index 9ae3b4a..89ae5bf 100755
--- a/ql-ol-kernel/drivers/power/Makefile
+++ b/ql-ol-kernel/drivers/power/Makefile
@@ -29,6 +29,7 @@ obj-$(CONFIG_BATTERY_IPAQ_MICRO) += ipaq_micro_battery.o
 obj-$(CONFIG_BATTERY_WM97XX)	+= wm97xx_battery.o
 obj-$(CONFIG_BATTERY_SBS)	+= sbs-battery.o
 obj-$(CONFIG_BATTERY_BQ27x00)	+= bq27x00_battery.o
+obj-$(CONFIG_BATTERY_BQ27441)   += bq27441_battery.o
 obj-$(CONFIG_BATTERY_DA9030)	+= da9030_battery.o
 obj-$(CONFIG_BATTERY_DA9052)	+= da9052-battery.o
 obj-$(CONFIG_BATTERY_MAX17040)	+= max17040_battery.o
@@ -79,3 +80,4 @@ obj-$(CONFIG_MSM_BCL_CTL)	+= msm_bcl.o
 obj-$(CONFIG_MSM_BCL_PERIPHERAL_CTL) += bcl_peripheral.o
 obj-$(CONFIG_POWER_RESET)	+= reset/
 obj-$(CONFIG_ARCH_MSM)		+= qcom/
+obj-$(CONFIG_BATTERY_CHARGER_GAUGE_COMM) += battery-charger-gauge-comm.o
diff --git a/ql-ol-kernel/drivers/power/bq27441_battery.c b/ql-ol-kernel/drivers/power/bq27441_battery.c
index a1c7b0d..44aeea7 100644
--- a/ql-ol-kernel/drivers/power/bq27441_battery.c
+++ b/ql-ol-kernel/drivers/power/bq27441_battery.c
@@ -29,8 +29,9 @@
 #include <linux/jiffies.h>
 #include <linux/regmap.h>
 #include <linux/power/bq27441_battery.h>
+#include <linux/time.h>
 
-#define BQ27441_DELAY			(30*HZ)
+#define BQ27441_DELAY			(0.1*HZ)
 
 #define BQ27441_CONTROL_STATUS		0x0000
 #define BQ27441_DEVICE_TYPE		0x0001
@@ -79,7 +80,8 @@
 #define BQ27441_BATTERY_FULL		100
 
 #define BQ27441_MAX_REGS		0x7F
-
+static int bq27441_update_battery_status(struct battery_gauge_dev *bg_dev,
+				int status);
 struct bq27441_chip {
 	struct i2c_client		*client;
 	struct delayed_work		work;
@@ -179,6 +181,12 @@ static void bq27441_work(struct work_struct *work)
 	else
 		chip->soc = val;
 
+	val = bq27441_read_word(chip->client, BQ27441_FLAGS);
+	if (val < 0)
+		dev_err(&chip->client->dev, "%s: err %d\n", __func__, val);
+	else
+		bq27441_update_battery_status(chip->bg_dev,val);
+
 	if (chip->status == POWER_SUPPLY_STATUS_FULL && chip->charge_complete) {
 		chip->soc = BQ27441_BATTERY_FULL;
 		chip->capacity_level = POWER_SUPPLY_CAPACITY_LEVEL_FULL;
@@ -373,22 +381,19 @@ static int bq27441_get_property(struct power_supply *psy,
 	return 0;
 }
 
+#define BQ27441_FLAG_FC			0x0200
+#define BQ27441_FLAG_CHGS		0x0001
+
 static int bq27441_update_battery_status(struct battery_gauge_dev *bg_dev,
-		enum battery_charger_status status)
+		int status)
 {
 	struct bq27441_chip *chip = battery_gauge_get_drvdata(bg_dev);
 
-	if (status == BATTERY_CHARGING)
-		chip->status = POWER_SUPPLY_STATUS_CHARGING;
-	else if (status == BATTERY_CHARGING_DONE) {
-		chip->charge_complete = 1;
-		chip->soc = BQ27441_BATTERY_FULL;
-		chip->status = POWER_SUPPLY_STATUS_FULL;
-		power_supply_changed(&chip->battery);
-		return 0;
-	} else {
+	if (status & BQ27441_FLAG_CHGS) {
 		chip->status = POWER_SUPPLY_STATUS_DISCHARGING;
-		chip->charge_complete = 0;
+	}
+	else if (status & BQ27441_FLAG_FC) {
+		chip->charge_complete = 1;
 	}
 	chip->lasttime_status = chip->status;
 	power_supply_changed(&chip->battery);
@@ -404,6 +409,34 @@ static struct battery_gauge_info bq27441_bgi = {
 	.bg_ops = &bq27441_bg_ops,
 };
 
+static void of_bq27441_parse_platform_data(struct i2c_client *client,
+				struct bq27441_platform_data *pdata)
+{
+	u32 tmp;
+	char const *pstr;
+	struct device_node *np = client->dev.of_node;
+
+	if (!of_property_read_u32(np, "ti,design-capacity", &tmp))
+		pdata->full_capacity = (unsigned long)tmp;
+
+	if (!of_property_read_u32(np, "ti,design-energy", &tmp))
+		pdata->full_energy = (unsigned long)tmp;
+
+	if (!of_property_read_u32(np, "ti,taper-rate", &tmp))
+		pdata->taper_rate = (unsigned long)tmp;
+
+	if (!of_property_read_u32(np, "ti,terminate-voltage", &tmp))
+		pdata->terminate_voltage = (unsigned long)tmp;
+
+	if (!of_property_read_u32(np, "ti,v-at-chg-term", &tmp))
+		pdata->v_at_chg_term = (unsigned long)tmp;
+
+	if (!of_property_read_string(np, "ti,tz-name", &pstr))
+		pdata->tz_name = pstr;
+	else
+		dev_err(&client->dev, "Failed to read tz-name\n");
+}
+
 static int bq27441_probe(struct i2c_client *client,
 			  const struct i2c_device_id *id)
 {
@@ -415,8 +448,16 @@ static int bq27441_probe(struct i2c_client *client,
 		return -ENOMEM;
 
 	chip->client = client;
+	if (client->dev.of_node) {
+		chip->pdata = devm_kzalloc(&client->dev,
+					sizeof(*chip->pdata), GFP_KERNEL);
+		if (!chip->pdata)
+			return -ENOMEM;
+		of_bq27441_parse_platform_data(client, chip->pdata);
+	} else {
+		chip->pdata = client->dev.platform_data;
+	}
 
-	chip->pdata = client->dev.platform_data;
 	if (!chip->pdata)
 		return -ENODATA;
 
diff --git a/ql-ol-kernel/drivers/thermal/thermal_core.c b/ql-ol-kernel/drivers/thermal/thermal_core.c
index b9b4847..392baa8 100755
--- a/ql-ol-kernel/drivers/thermal/thermal_core.c
+++ b/ql-ol-kernel/drivers/thermal/thermal_core.c
@@ -433,6 +433,29 @@ int thermal_sensor_trip(struct thermal_zone_device *tz,
 }
 EXPORT_SYMBOL(thermal_sensor_trip);
 
+/* Added support for thermal_zone_device_find_by_name in thermal core .c file */
+
+struct thermal_zone_device *thermal_zone_device_find_by_name(const char *name)
+{
+	struct thermal_zone_device *thz;
+	int ret;
+	if (!name)
+		return NULL;
+
+	mutex_lock(&thermal_list_lock);
+	list_for_each_entry(thz, &thermal_tz_list, node)
+	ret = strncmp(name,"battery-temp", strlen(name));
+	if (!ret) {
+		mutex_unlock(&thermal_list_lock);
+		return thz;
+	}
+
+	mutex_unlock(&thermal_list_lock);
+	return NULL;
+}
+EXPORT_SYMBOL(thermal_zone_device_find_by_name);
+
+
 int sensor_get_temp(uint32_t sensor_id, long *temp)
 {
 	struct sensor_info *sensor = get_sensor(sensor_id);
diff --git a/ql-ol-kernel/include/linux/power/bq27441_battery.h b/ql-ol-kernel/include/linux/power/bq27441_battery.h
index 8f3ab2e..ef68346 100644
--- a/ql-ol-kernel/include/linux/power/bq27441_battery.h
+++ b/ql-ol-kernel/include/linux/power/bq27441_battery.h
@@ -19,6 +19,11 @@
 
 struct bq27441_platform_data {
 	unsigned long full_capacity_in_mAh;
+	unsigned long full_capacity;
+	unsigned long full_energy;
+	unsigned long taper_rate;
+	unsigned long v_at_chg_term;
+	unsigned long terminate_voltage;
 	const char *tz_name;
 };
 
diff --git a/ql-ol-kernel/include/linux/thermal.h b/ql-ol-kernel/include/linux/thermal.h
index 9414884..a72a793 100755
--- a/ql-ol-kernel/include/linux/thermal.h
+++ b/ql-ol-kernel/include/linux/thermal.h
@@ -435,6 +435,10 @@ int thermal_zone_unbind_cooling_device(struct thermal_zone_device *, int,
 				       struct thermal_cooling_device *);
 void thermal_zone_device_update(struct thermal_zone_device *);
 
+/* Added thermal_zone_device_find_by_name file in thermal.h */
+
+struct thermal_zone_device *thermal_zone_device_find_by_name(const char *name);
+
 struct thermal_cooling_device *thermal_cooling_device_register(char *, void *,
 		const struct thermal_cooling_device_ops *);
 struct thermal_cooling_device *
-- 
2.7.4

